import { type ProgramClient } from "@peerbit/program";
import { PeerbitProxyClient, PeerbitProxyHost, connection } from "@peerbit/proxy";
type WindowFunctions = {
    addEventListener: <K extends keyof WindowEventMap>(type: K, listener: (this: Window, ev: WindowEventMap[K]) => any, options?: boolean | AddEventListenerOptions) => void;
    postMessage: (message: any, targetOrigin: string, transfer?: Transferable[]) => void;
    top: WindowFunctions | null;
};
export declare class PostMessageNode extends connection.MessageNode {
    readonly targetOrigin: string;
    readonly windowHandle: WindowFunctions;
    static messagePrefixKey: string;
    constructor(targetOrigin?: string, windowHandle?: WindowFunctions);
}
export declare const createClient: (targetOrigin?: string) => Promise<PeerbitProxyClient>;
export declare const createHost: (node: ProgramClient, targetOrigin?: string) => Promise<PeerbitProxyHost>;
export {};
//# sourceMappingURL=index.d.ts.map